"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const __1 = __importDefault(require(".."));
const opts = {
    name: 'api-workflow',
    description: 'My workflow',
    version: '',
    eventTriggers: [],
    cronTriggers: [],
    scheduledTriggers: [],
    concurrency: undefined,
    jobs: [
        {
            name: 'my-job',
            description: 'Job description',
            steps: [
                {
                    retries: 0,
                    readableId: 'custom-step',
                    action: `slack:example`,
                    timeout: '60s',
                    inputs: '{}',
                    parents: [],
                    workerLabels: {},
                    userData: `{
            "example": "value"
          }`,
                    rateLimits: [],
                },
            ],
        },
    ],
};
function main() {
    return __awaiter(this, void 0, void 0, function* () {
        const hatchet = __1.default.init();
        const { admin } = hatchet;
        yield admin.putWorkflow(opts);
        const worker = yield hatchet.worker('example-worker');
        worker.registerAction('slack:example', (ctx) => __awaiter(this, void 0, void 0, function* () {
            const setData = ctx.userData();
            console.log('executed step1!', setData);
            return { step1: 'step1' };
        }));
        yield hatchet.admin.runWorkflow('api-workflow', {});
        worker.start();
    });
}
main();
